program AVR_SerDAC;

{$Define PORTmode}
{ $Define PORTbitmode}

Device = mega128, VCC=5;

Define_Fuses
  COMport   = USB;
  LockBits0 = [];
  FuseBits0 = [];
  FuseBits1 = [CKOPT, SPIEN, JTAGEN, OCDEN];
  FuseBits2 = [];
  ProgMode  = JTAG;

Import SPIdriver;

From System Import ;

Define
  ProcClock   = 16000000;        {Hertz}
  StackSize   = $0064, iData;
  FrameSize   = $0064, iData;

  SPIorder    = LSB;
  SPIcpol     = 1;
  SPIcpha     = 1;
  SPIpresc    = 0;              // presc = 0..3 -> 4/16/64/128
  SPI_SS      = true;           // use SS pin as chipselect

Implementation

{$IDATA}

{--------------------------------------------------------------}
{ Type Declarations }

type


{--------------------------------------------------------------}
{ Const Declarations }
const
  DACStrobe  : byte  = 4;               // bit mask
  DACdata    : byte  = 1;               // bit mask
  DACclock   : byte  = 2;               // bit mask

{--------------------------------------------------------------}
{ Var Declarations }
var
  DACport[@PORTG] : byte;
  
{$IDATA}
var
  bb           : byte;


{--------------------------------------------------------------}
{ functions }
{$NOFRAME}
procedure PortOut(b : byte);
begin
  ASM;
    LDS       _ACCCLO, AVR_SerDAC.DACport;
    CBR       _ACCCLO, AVR_SerDAC.DACstrobe;
    STS       AVR_SerDAC.DACport, _ACCCLO;
    LDI       _ACCB, 8;
  Label1:
    SBR       _ACCCLO, AVR_SerDAC.DACdata;           // set data 1
    ROR       _ACCA;
    BRCS      Label2;
    CBR       _ACCCLO, AVR_SerDAC.DACdata;           // set data 0
  Label2:
    STS       AVR_SerDAC.DACport, _ACCCLO;
    SBR       _ACCCLO, AVR_SerDAC.DACclock;          // set clk bit
    STS       AVR_SerDAC.DACport, _ACCCLO;
    CBR       _ACCCLO, AVR_SerDAC.DACclock;          // clr clk bit
    STS       AVR_SerDAC.DACport, _ACCCLO;
    DEC       _ACCB;
    BRNE      Label1;
    SBR       _ACCCLO, AVR_SerDAC.DACstrobe;
    STS       AVR_SerDAC.DACport, _ACCCLO;
    CBR       _ACCCLO, AVR_SerDAC.DACstrobe;
    STS       AVR_SerDAC.DACport, _ACCCLO;
  EndASM;
end;


{--------------------------------------------------------------}
{ Main Program }
{$IDATA}

begin
  DDRG:= DDRG or 7;           // bit 0..2 output in port bit mode
  DDRC:= $FF;                 // all output in port mode

  loop
{$IFDEF PORTbitmode}
    PortOut(bb);
{$ELSIFDEF PORTmode}
    PortC:= Mirror8(bb);      // mirror, because a layout bug on board
{$ELSE}
    SPIoutByte(bb);
{$ENDIF}
    inc(bb);
  endloop;
end AVR_SerDAC.

